-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if cfg.release>=7 then
lib.classes["DRUID"] = {}
local t,s
lib.classes["DRUID"][1] = function() --Moonkin
	lib.SetPower("LUNAR_POWER")
	lib.AddResourceBar(cfg.Power.max)
	lib.ChangeResourceBarType(cfg.Power.type)
	cfg.cleave_threshold=3
	lib.AddSpell("Moonfire",{8921})
	lib.AddAura("Moonfire",164812,"debuff","target")
	lib.SetDOT("Moonfire")
	lib.AddSpell("Sunfire",{93402})
	lib.AddAura("Sunfire",164815,"debuff","target")
	lib.AddSpell("Stellar Flare",{202347})
	lib.AddAura("Stellar Flare",202347,"debuff","target")
	lib.AddSpell("Starsurge",{78674})
	lib.AddSpell("Starfall",{191034},true)
	lib.AddCleaveSpell("Starfall",nil,{191037})
	lib.AddSpell("New Moon",{202767,202768,202771})
	lib.SetSpellCost("New Moon",-10,"power")
	lib.SetSpellIcon("New Moon",(GetSpellTexture(202771)))
	--[[lib.OnSpellCast("New Moon",function()
		--print("oncast "..(IsPlayerSpell(202767) and "true" or "false")..(IsPlayerSpell(202768) and "true" or "false")..(IsPlayerSpell(202771) and "true" or "false"))
		--lib.ReloadSpell("New Moon",{202768,202767,202771})
		--print(GetSpellTexture(202768))
		if lib.GetSpellCharges("New Moon")>=3 then
			lib.SetSpellIcon("New Moon",(GetSpellTexture(202767)))
		elseif lib.GetSpellCharges("New Moon")==2 then
			lib.SetSpellIcon("New Moon",(GetSpellTexture(202768)))
		else
			lib.SetSpellIcon("New Moon",(GetSpellTexture(202771)))
		end
	end)]]
	--lib.AddSpell("Half Moon",{202768})
	--lib.AddSpell("Full Moon",{202771})
	lib.AddSpell("Solar Wrath",{190984})
	lib.SetSpellCost("Solar Wrath",-8,"power")
	lib.AddSpell("Celestial Alignment",{102560,194223},true)
	lib.AddSpell("Lunar Strike",{194153})
	lib.SetSpellCost("Lunar Strike",-12,"power")
	lib.AddSpell("Astral Communion",{202359})
	lib.AddSpell("Warrior of Elune",{202425},true)
	lib.AddSpell("Force of Nature",{205636})
	
	lib.AddAura("Lunar Empowerment",164547,"buff","player")
	lib.AddAura("Owlkin Frenzy",157228,"buff","player")
	lib.AddAura("Solar Empowerment",164545,"buff","player")
	lib.AddAura("Stellar Empowerment",197637,"debuff","target")
	lib.AddSpell("Moonkin",{24858})
	lib.SetTrackAura({"Owlkin Frenzy","Solar Empowerment","Lunar Empowerment","Starfall"})
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Moonkin_noMoonkin")
	table.insert(cfg.plistdps,"Warrior of Elune")
	table.insert(cfg.plistdps,"Force of Nature")
	table.insert(cfg.plistdps,"Celestial Alignment")
	table.insert(cfg.plistdps,"Starfall_aoe")
	table.insert(cfg.plistdps,"Moonfire_noMoonfire")
	table.insert(cfg.plistdps,"Sunfire_noSunfire")
	table.insert(cfg.plistdps,"Stellar Flare_noStellar Flare")
	table.insert(cfg.plistdps,"Astral Communion")
	table.insert(cfg.plistdps,"Lunar Strike_Owlkin Frenzy")
	table.insert(cfg.plistdps,"Solar Wrath3")
	table.insert(cfg.plistdps,"Lunar Strike3")
	table.insert(cfg.plistdps,"Starsurge")
	table.insert(cfg.plistdps,"New Moon")
	table.insert(cfg.plistdps,"Lunar Strike_4_aoe")
	table.insert(cfg.plistdps,"Lunar Strike_3_aoe")
	table.insert(cfg.plistdps,"Solar Wrath")
	table.insert(cfg.plistdps,"end")
	cfg.plist=cfg.plistdps
	
	cfg.case = {
		["Moonkin_noMoonkin"] = function()
			if cfg.shape.name~="Moonkin" then
				return lib.SimpleCDCheck("Moonkin")
			end
			return nil
		end,
		["Astral Communion"] = function()
			if cfg.Power.now+75<cfg.Power.max then
				return lib.SimpleCDCheck("Astral Communion")
			end
			return nil
		end,
		["Starsurge"] = function()
			if cfg.noaoe or cfg.cleave_targets<cfg.cleave_threshold then
				return lib.SimpleCDCheck("Starsurge")
			end
			return nil
		end,
		["Starfall_aoe"] = function()
			if cfg.cleave_targets>=cfg.cleave_threshold then
				return lib.SimpleCDCheck("Starfall")
			end
			return nil
		end,
		
		["Lunar Strike3"] = function ()
			if lib.GetAuraStacks("Lunar Empowerment")>=3 and not lib.SpellCasting("Lunar Strike") then
				return lib.SimpleCDCheck("Lunar Strike")
			end
			return nil
		end,
		["Lunar Strike_Owlkin Frenzy"] = function ()
			if lib.GetAura({"Owlkin Frenzy"})>0 then
				return lib.SimpleCDCheck("Lunar Strike")
			end
			return nil
		end,
		["Lunar Strike_3_aoe"] = function ()
			if cfg.cleave_targets<cfg.cleave_threshold then return nil end
			if lib.GetAuraStacks("Lunar Empowerment")>1 or (lib.GetAuraStacks("Lunar Empowerment")>0 and not lib.SpellCasting("Lunar Strike")) then
				return lib.SimpleCDCheck("Lunar Strike")
			end
			return nil
		end,
		["Lunar Strike_4_aoe"] = function ()
			if cfg.cleave_targets<4 then return nil end
			return lib.SimpleCDCheck("Lunar Strike")
		end,
		["Warrior of Elune"] = function ()
			if lib.GetAuraStacks("Lunar Empowerment")>=3 then
				return lib.SimpleCDCheck("Warrior of Elune")
			end
			return nil
		end,
		["New Moon"] = function ()
			if lib.SpellCastingId({202767,202768,202771}) and lib.GetSpellCharges("New Moon")<2 then return nil end
			return lib.SimpleCDCheck("New Moon")
		end,
		["Solar Wrath3"] = function ()
			if lib.GetAuraStacks("Solar Empowerment")>=3 and not lib.SpellCasting("Solar Wrath") then
				return lib.SimpleCDCheck("Solar Wrath")
			end
			return nil
		end,
		["Moonfire_noMoonfire"] = function ()
			return lib.SimpleCDCheck("Moonfire",lib.GetAura({"Moonfire"})-4.8)
		end,
		["Stellar Flare_noStellar Flare"] = function ()
			if lib.SpellCasting("Stellar Flare") then return nil end
			return lib.SimpleCDCheck("Stellar Flare",lib.GetAura({"Stellar Flare"})-7.2)
		end,
		["Sunfire_noSunfire"] = function ()
			return lib.SimpleCDCheck("Sunfire",lib.GetAura({"Sunfire"})-3.6)
		end,
	}
	
	lib.AddRangeCheck({
	{"Moonfire",nil}
	})
	
	--[[cfg.eclipse=UnitPower('player', SPELL_POWER_ECLIPSE)
	
	lib.myonpower=function(unit,powerType)
		if unit=="player" and powerType == 'ECLIPSE' then
			cfg.eclipse=UnitPower('player', SPELL_POWER_ECLIPSE)
			cfg.Update=true
		end
	end]]
	return true
end

lib.classes["DRUID"][3] = function() --Bear
	lib.SetSpellIcon("aa","Interface\\Icons\\Ability_Druid_CatFormAttack",true)
	lib.SetPower("RAGE")
	lib.AddResourceBar(cfg.Power.max)
	lib.ChangeResourceBarType(cfg.Power.type)
	cfg.bear_moonfire=16*0.3
	lib.AddSpell("Mangle",{33917}) -- Mangle
	--lib.AddAura("Regrowth",145162,"buff","player") -- Dream of Cenarius
	lib.AddSpell("Moonfire",{8921})
	--lib.FixSpell("Moonfire","cost")
	lib.AddAura("Moonfire",164812,"debuff","target")
	lib.AddAura("Galactic Guardian",213708,"buff","player")
	
	--lib.AddSpell("Pulverize",{80313}) -- Pulverize
	--lib.AddAura("Pulverize",158792,"buff","player") -- Pulverize
	--lib.SetTrackAura("Pulverize")
	lib.AddSpell("Thrash",{77758})--,"target"
	lib.AddAura("Thrash",192090,"debuff","target")
	lib.AddCleaveSpell("Thrash",nil,{77758,192090})
	
	lib.AddSpell("Swipe",{213764,213771})
	lib.AddCleaveSpell("Swipe")
	lib.SetDOT("Thrash")
	lib.AddSpell("Maul",{6807}) -- Maul
	--lib.AddAura("TaC",135286,"buff","player") -- Tooth and Claw
	lib.AddSpell("Bear",{5487}) -- Bear Form
	lib.AddSpell("Frenzied Regeneration",{22842},true) -- Frenzied Regeneration
	lib.AddSpell("Ironfur",{192081},true)
	lib.AddSpell("Mark of Ursol",{192083},true)
	lib.AddSpell("Rage of the Sleeper",{200851},true)
	--lib.AddSpell("Defense",{62606}) -- Savage Defense
	--lib.AddAura("Defense",132402,"buff","player") -- Savage Defense
	lib.AddSpell("Barkskin",{22812},true) -- Barkskin
	lib.AddSpell("Instincts",{61336},true) -- Survival Instincts
	lib.SetTrackAura({"Galactic Guardian","Instincts","Rage of the Sleeper","Barkskin","Ironfur","Mark of Ursol"})

	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Bear_noBear")
	table.insert(cfg.plistdps,"Ironfur")
	table.insert(cfg.plistdps,"Mark of Ursol")
	table.insert(cfg.plistdps,"Frenzied Regeneration")
	table.insert(cfg.plistdps,"Moonfire_range")
	table.insert(cfg.plistdps,"Moonfire_Galactic Guardian")
	table.insert(cfg.plistdps,"Rage of the Sleeper")
	table.insert(cfg.plistdps,"Thrash_aoe")
	table.insert(cfg.plistdps,"Mangle")
	table.insert(cfg.plistdps,"Thrash")
	table.insert(cfg.plistdps,"Swipe_aoe")
	table.insert(cfg.plistdps,"Moonfire_noMoonfire")
	table.insert(cfg.plistdps,"Swipe")
	table.insert(cfg.plistdps,"Maul_nocap")
	table.insert(cfg.plistdps,"Ironfur_nocap")
	table.insert(cfg.plistdps,"Ursol_nocap")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = nil
	cfg.case = {
		["Moonfire_range"] = function()
			if lib.inrange("Mangle") then return nil end
			return lib.SimpleCDCheck("Moonfire",lib.GetAura({"Moonfire"})-cfg.bear_moonfire)
		end,
		["Moonfire_noMoonfire"] = function()
			return lib.SimpleCDCheck("Moonfire",lib.GetAura({"Moonfire"})-cfg.bear_moonfire)
		end,
		["Thrash_aoe"] = function()
			if cfg.cleave_targets>=2 then
				return lib.SimpleCDCheck("Thrash")
			end
			return nil
		end,
		["Swipe_aoe"] = function()
			if cfg.cleave_targets>=4 then
				return lib.SimpleCDCheck("Swipe")
			end
			return nil
		end,
		["Moonfire_Galactic Guardian"] = function()
			if lib.GetAura({"Galactic Guardian"})>lib.GetSpellCD("Moonfire") then
				return lib.SimpleCDCheck("Moonfire")
			end
			return nil
		end,
		["Bear_noBear"] = function()
			if cfg.shape.name~="Bear" then
				return lib.SimpleCDCheck("Bear")
			end
			return nil
		end,
		["Defense_HP"] = function()
			if cfg.Power.now>=60 and lib.GetUnitHealth("player","percent")<=70 then
				return lib.SimpleCDCheck("Defense",lib.GetAura({"Defense"}))
			end
		end,
		["Frenzied Regeneration"] = function()
			if cfg.Power.now>=10 and lib.GetUnitHealth("player","percent")<=70 then
				return lib.SimpleCDCheck("Frenzied Regeneration",lib.GetAura({"Frenzied Regeneration"}))
			end
		end,
		["Ironfur"] = function()
			if cfg.Power.now>=45 and lib.GetUnitHealth("player","percent")<=70 then
				return lib.SimpleCDCheck("Ironfur")
			end
		end,
		["Mark of Ursol"] = function()
			if cfg.Power.now>=45 and lib.GetUnitHealth("player","percent")<=70 then
				return lib.SimpleCDCheck("Mark of Ursol",lib.GetAura({"Mark of Ursol"}))
			end
		end,
		["Maul_nocap"] = function()
			if cfg.Power.now>=cfg.Power.max-20 then
				return lib.SimpleCDCheck("Maul")
			end
			return nil
		end,
		["Ironfur_nocap"] = function()
			if cfg.Power.now>=cfg.Power.max-20 then
				return lib.SimpleCDCheck("Ironfur")
			end
			return nil
		end,
		["Ursol_nocap"] = function()
			if cfg.Power.now>=cfg.Power.max-20 then
				return lib.SimpleCDCheck("Ursol")
			end
			return nil
		end,
	}
	
	cfg.plist=cfg.plistdps
	lib.SetInterrupt("Kick",{106839})
	
	lib.AddRangeCheck({
	{"Mangle",nil},
	{"Kick",{0,0,1,1}},
	{"Moonfire",{1,1,0,1}},
	})
	
	return true
end

lib.classes["DRUID"][2] = function() --Cat
	cfg.Cat={}
	cfg.Cat.Rip={}
	cfg.Cat.Rake={}
	lib.OnTargetChanged=function()
		if lib.GetAura({"Rip"})==0 then
			cfg.Cat.Rip[cfg.GUID["target"]]=0
		else
			cfg.Cat.Rip[cfg.GUID["target"]]=cfg.Cat.Rip[cfg.GUID["target"]] or 0
		end
		if cfg.Cat.Rip[cfg.GUID["target"]]>0 then
			Heddmain.info:SetText(math.floor(cfg.Cat.Rip[cfg.GUID["target"]]*100).."%") 
		else
			Heddmain.info:SetText("")
		end
		if lib.GetAura({"Rake"})==0 then
			cfg.Cat.Rake[cfg.GUID["target"]]=0
		else
			cfg.Cat.Rake[cfg.GUID["target"]]=cfg.Cat.Rake[cfg.GUID["target"]] or 0
		end
		if cfg.Cat.Rake[cfg.GUID["target"]]>0 then
			Heddmain.info_DOT:SetText(math.floor(cfg.Cat.Rake[cfg.GUID["target"]]*100).."%")
		else
			Heddmain.info_DOT:SetText("")
		end
	end
	cfg.talents={
		["Bloodtalons"]=IsPlayerSpell(155672),
		["Lunar Inspiration"]=IsPlayerSpell(155580),
		["Sabertooth"]=IsPlayerSpell(202031),
		["Jagged Wounds"]=IsPlayerSpell(202032),
		["Incarnation: King of the Jungle"]=IsPlayerSpell(102543),
		["Brutal Slash"]=IsPlayerSpell(202028),
		["Savage Roar"]=IsPlayerSpell(52610),
		["Soul of the Forest"]=IsPlayerSpell(158476),
	}
	if cfg.talents["Sabertooth"] then
		cfg.cat_rip=0
	else
		cfg.cat_rip=24*(1-0.33*(cfg.talents["Jagged Wounds"] and 1 or 0))*0.3
		lib.OnUpdateHealth = function(unitID)
			if unitID=="target" then
				if cfg.health[unitID].percent>25 or cfg.health[unitID].percent==0 then
					cfg.cat_rip=24*(1-0.33*(cfg.talents["Jagged Wounds"] and 1 or 0))*0.3
				else
					cfg.cat_rip=0
				end
			end
		end
	end
	lib.AddAura("Predatory Swiftness",69369,"buff","player")
	if cfg.talents["Bloodtalons"] then
		lib.AddAura("Bloodtalons",145152,"buff","player")
	end
	
	cfg.cat_rake=12*(1-0.33*(cfg.talents["Jagged Wounds"] and 1 or 0))*0.3
	cfg.cat_roar=(cfg.talents["Jagged Wounds"] and 10.5 or 24*0.3)
	cfg.cat_thrash=15*(1-0.33*(cfg.talents["Jagged Wounds"] and 1 or 0))*0.3
	cfg.cat_moonfire=14*0.3
	
	cfg.cleave_threshold=3
	lib.SetSpellIcon("aa","Interface\\Icons\\Ability_Druid_CatFormAttack",true)
	lib.SetPower("ENERGY")
	lib.SetAltPower("COMBO_POINTS")
	lib.LoadSwingTimer(true)
	--cfg.set["T13"]={}
	--cfg.set["T13"]={77013,77014,77015,77016,77017,78743,78665,78713,78694,78684,78838,78760,78808,78789,78779}
	lib.AddSet("T19",{138324,138327,138330,138333,138336,138366})
	lib.AddSet("Ailuro Pouncers",{137024})
	lib.AddSpell("Cat",{768})
	lib.AddSpell("Rejuvenation",{774},true) -- Rejuvenation
	lib.AddSpell("Rake",{1822}) -- Rake
	lib.AddSpell("Berserk",{102543,106951},true)
	lib.AddSpell("Elune's Guidance",{202060},true)
	lib.AddAura("Rake",155722,"debuff","target") -- Rake
	lib.AddItem("Draught of Souls",140808,225141)
	lib.SetDOT("Rake",3)
	lib.SetAuraFunction("Rake","OnFade",function(num_func,spell)
		cfg.Cat.Rake[cfg.GUID["target"]]=0
		Heddmain.info_DOT:SetText("")
	end)
	lib.AddSpell("Shred",{5221}) -- Shred
	lib.AddSpell("Ashamane's Frenzy",{210722})
	lib.AddSpell("Savage Roar",{52610},true) -- Savage Roar
	lib.AddSpell("Rip",{1079},"target") -- Rip
	lib.SetAuraFunction("Rip","OnFade",function(num_func,spell)
		cfg.Cat.Rip[cfg.GUID["target"]]=0
		Heddmain.info:SetText("")
	end)
	cfg.Cat.Buffs_Rip ={
	["Tiger's Fury"]=1.15,
	["Bloodtalons"]=1.50,
	["Savage Roar"]=1.25,
	--["Berserk"]=1.15
	}
	cfg.Cat.Buffs_Rake ={
	["Tiger's Fury"]=1.15,
	["Bloodtalons"]=1.50,
	["Savage Roar"]=1.25,
	--["Berserk"]=1.15,
	["Prowl"]=2
	}
	
	if cfg.talents["Incarnation: King of the Jungle"] then
		cfg.Cat.Buffs_Rake["Berserk"]=2
	end
	lib.OnSpellCast("Rip",function()
		cfg.Cat.Rip[cfg.GUID["target"]]=lib.AurasCount(cfg.Cat.Buffs_Rip,true)
		if cfg.Cat.Rip[cfg.GUID["target"]]>0 then
			Heddmain.info:SetText(math.floor(cfg.Cat.Rip[cfg.GUID["target"]]*100).."%") 
		else
			Heddmain.info:SetText("")
		end
	end)
	lib.OnSpellCast("Rake",function()
		cfg.Cat.Rake[cfg.GUID["target"]]=lib.AurasCount(cfg.Cat.Buffs_Rake,true)
		if cfg.Cat.Rake[cfg.GUID["target"]]>0 then
			Heddmain.info_DOT:SetText(math.floor(cfg.Cat.Rake[cfg.GUID["target"]]*100).."%")
		else
			Heddmain.info_DOT:SetText("")
		end
	end)
	if cfg.talents["Lunar Inspiration"] then
		lib.AddSpell("Moonfire",{8921}) -- Moonfire
		lib.AddAura("Moonfire",155625,"debuff","target") -- Moonfire
		lib.FixSpell("Moonfire","cost")
		lib.OnSpellCast("Cat",function()
			lib.ReloadSpell("Moonfire")
			lib.FixSpell("Moonfire","cost")
			end)
	end
	lib.AddSpell("Ferocious Bite",{22568}) -- Ferocious Bite
	lib.AddSpell("Tiger's Fury",{5217},true) -- Tiger's Fury
	lib.AddSpell("Charge",{49376}) -- Feral Charge
	lib.AddSpell("Thrash",{106830},"target",nil,nil,nil,true) --106832
	--lib.ChangeSpellID("Thrash",106830,true)
	--lib.FixSpell("Thrash","cost")
	--lib.AddAura("Thrash",106830,"debuff","target")
	lib.AddCleaveSpell("Thrash",nil,{106830})
	if cfg.talents["Brutal Slash"] then
		lib.AddSpell("Brutal Slash",{202028})
		lib.FixSpell("Brutal Slash","cost")
		lib.AddCleaveSpell("Brutal Slash")
	else
		lib.AddSpell("Swipe",{213764,106785})
		lib.FixSpell("Swipe","cost")
		lib.AddCleaveSpell("Swipe",nil,{213764,106785})
	end
	
	lib.AddAura("Clearcasting",135700,"buff","player")
	lib.AddSpell("Prowl",{5215},true)
	lib.AddSpell("Regrowth",{8936},true)
	if cfg.talents["Bloodtalons"] then
		lib.SetTrackAura({"Bloodtalons","Clearcasting","Predatory Swiftness","Berserk","Tiger's Fury","Savage Roar"})
	else
		lib.SetTrackAura({"Clearcasting","Berserk","Tiger's Fury","Savage Roar"})
	end
	lib.AddSpell("Instincts",{61336},true) -- Survival Instincts
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Draught of Souls")
	if cfg.talents["Bloodtalons"] then
		table.insert(cfg.plistdps,"Regrowth_Bloodtalons_nocombat")
	end
	table.insert(cfg.plistdps,"Cat_noCat")
	table.insert(cfg.plistdps,"Prowl_nocombat")
	if cfg.talents["Savage Roar"] then
		table.insert(cfg.plistdps,"Savage Roar_nocombat")
	end
	table.insert(cfg.plistdps,"Rake_Prowl")
	if cfg.talents["Bloodtalons"] then
		table.insert(cfg.plistdps,"Regrowth_Bloodtalons_proc")
	else
		table.insert(cfg.plistdps,"Regrowth_Heal")
	end
	table.insert(cfg.plistdps,"Berserk_TF")
	table.insert(cfg.plistdps,"Tiger's Fury")
	
	if cfg.talents["Bloodtalons"] then
		table.insert(cfg.plistdps,"Regrowth_Bloodtalons_max")
	end
	table.insert(cfg.plistdps,"Rip_buffed")
	table.insert(cfg.plistdps,"Ferocious Bite_Rip")
	if cfg.talents["Bloodtalons"] and lib.GetSet("Ailuro Pouncers")>0 then
		table.insert(cfg.plistdps,"Regrowth_Ailuro Pouncers")
	end
	
	if cfg.talents["Savage Roar"] then
		table.insert(cfg.plistdps,"Savage Roar_noSavage Roar")
	end
	table.insert(cfg.plistdps,"Thrash_noThrash_5_aoe")
	if cfg.talents["Brutal Slash"] then
		table.insert(cfg.plistdps,"Brutal Slash_Thrash_aoe")
	else
		table.insert(cfg.plistdps,"Swipe_Thrash_8_aoe")
	end
	table.insert(cfg.plistdps,"Rip_noRip")
	if cfg.talents["Savage Roar"] then
		table.insert(cfg.plistdps,"Savage Roar_noSavage Roar_renew")
	end
	table.insert(cfg.plistdps,"Swipe_6_aoe")
	table.insert(cfg.plistdps,"Ferocious Bite_5")
	if cfg.talents["Savage Roar"] and not cfg.talents["Sabertooth"] then
		table.insert(cfg.plistdps,"CP_5")
	end
	table.insert(cfg.plistdps,"Thrash_noThrash_aoe")
	if cfg.talents["Brutal Slash"] then
		table.insert(cfg.plistdps,"Brutal Slash_2_aoe")
	end
	table.insert(cfg.plistdps,"Ashamane's Frenzy")
	table.insert(cfg.plistdps,"Elune's Guidance")
	if cfg.talents["Brutal Slash"] then
		table.insert(cfg.plistdps,"Thrash_9_Brutal Slash_aoe")
	end
	--table.insert(cfg.plistdps,"Swipe_6_aoe")
	--shadowmeld
	table.insert(cfg.plistdps,"Rake_noRake")
	if cfg.talents["Lunar Inspiration"] then
		table.insert(cfg.plistdps,"Moonfire_noMoonfire")
	end
	table.insert(cfg.plistdps,"Rake_noRake_renew")
	if lib.SetBonus("T19")>0 then
		table.insert(cfg.plistdps,"Thrash_Clearcasting")
	end
	if cfg.talents["Brutal Slash"] then
		table.insert(cfg.plistdps,"Brutal Slash_single")
	end
	table.insert(cfg.plistdps,"Swipe_3_aoe")
	table.insert(cfg.plistdps,"Shred")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	cfg.plistaoe=nil

	cfg.case = {
		["Draught of Souls"] = function()
			if cfg.noaoe or cfg.cleave_targets<cfg.cleave_threshold then
				if (lib.Time2Power(cfg.Power.max)>lib.GetSpellCD("Draught of Souls")+3 or
				lib.GetAura({"Tiger's Fury"})>lib.GetSpellCD("Draught of Souls")) and
				lib.GetAura({"Rake"})>lib.GetSpellCD("Draught of Souls")+3 and
				lib.GetAura({"Rip"})>lib.GetSpellCD("Draught of Souls")+3 then
					return lib.SimpleCDCheck("Draught of Souls",lib.GetAura({"Tiger's Fury"})-3)
				end
			end
			return nil
		end,
		["Thrash_Bloodtalons_aoe"] = function()
			if cfg.cleave_targets>=cfg.cleave_threshold then
				if cfg.AltPower.now==0 and lib.GetAura({"Bloodtalons"})>lib.GetSpellCD("Thrash") then
					return lib.SimpleCDCheck("Thrash")
				end
			end
			return nil
		end,
		["Thrash_noThrash_5_aoe"] = function()
			if cfg.cleave_targets>=5 then
				return lib.SimpleCDCheck("Thrash",lib.GetAura({"Thrash"})-cfg.cat_thrash)
			end
			return nil
		end,
		--[[["Thrash_aoe"] = function()
			if cfg.cleave_targets>=cfg.cleave_threshold then
				return lib.SimpleCDCheck("Thrash",lib.GetAura({"Thrash"})-cfg.cat_thrash)
			end
			return nil
		end,]]
		["Thrash_noThrash_aoe"] = function()
			if lib.SetBonus("T19")>0 and cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.cleave_targets>=cfg.cleave_threshold then
				return lib.SimpleCDCheck("Thrash",lib.GetAura({"Thrash"})-cfg.cat_thrash)
			end
			return nil
		end,
		["Swipe_Thrash_8_aoe"] = function()
			if lib.GetAura({"Thrash"})<lib.GetSpellCD("Swipe") then return nil end
			if cfg.cleave_targets>=8 then
				return lib.SimpleCDCheck("Swipe")
			end
			return nil
		end,
		--[[["Swipe_6_aoe"] = function()
			if cfg.AltPower.now>=5 and (cfg.cleave_targets>=6 or (cfg.cleave_targets>=3 and not cfg.talents["Bloodtalons"])) then
				if lib.GetAura({"Berserk"})>lib.GetSpellCD("Swipe") or lib.GetAura({"Elune's Guidance"})>lib.GetSpellCD("Swipe") then
					return lib.SimpleCDCheck("Swipe")
				else
					return lib.SimpleCDCheck("Swipe",lib.Time2Power(cfg.Power.max))
				end
			end
			return nil
		end,]]
		["Thrash_Clearcasting"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if lib.GetAura({"Clearcasting"})>lib.GetSpellCD("Thrash") or lib.GetAura({"Berserk"})>lib.GetSpellCD("Thrash") then
				return lib.SimpleCDCheck("Thrash",lib.GetAura({"Thrash"})-cfg.cat_thrash) --math.max(lib.GetAura({"Bloodtalons"}),lib.GetAura({"Thrash"})-cfg.cat_thrash))
			end
			return nil
		end,
		
		["Thrash_9_Brutal Slash_aoe"] = function()
			if cfg.cleave_targets>=9 and lib.GetSpellCD("Brutal Slash")>cfg.gcd then
				return lib.SimpleCDCheck("Thrash")
			end
			return nil
		end,
		["Swipe_aoe"] = function()
			if lib.GetAura({"Thrash"})<lib.GetSpellCD("Swipe") then return nil end
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.cleave_targets>=cfg.cleave_threshold then
				if lib.GetSpellCost("Swipe")<45 then
					return lib.SimpleCDCheck("Swipe")
				else
					return lib.SimpleCDCheck("Swipe",lib.Time2Power(50))
				end
			end
			return nil
		end,
		["Swipe_6_aoe"] = function()
			if lib.GetAura({"Thrash"})<lib.GetSpellCD("Swipe") then return nil end
			if cfg.cleave_targets>=6 then
				return lib.SimpleCDCheck("Swipe")
			end
			return nil
		end,
		["Swipe_3_aoe"] = function()
			if lib.GetAura({"Thrash"})<lib.GetSpellCD("Swipe") then return nil end
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.cleave_targets>=3 then
				return lib.SimpleCDCheck("Swipe")
			end
			return nil
		end,
		
		["Brutal Slash_2_aoe"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.cleave_targets>=2 then
				return lib.SimpleCDCheck("Brutal Slash")
			end
			return nil
		end,
		["Brutal Slash_Thrash_aoe"] = function()
			if cfg.cleave_targets>=cfg.cleave_threshold and lib.GetAura({"Thrash"})>lib.GetSpellCD("Brutal Slash") then
				return lib.SimpleCDCheck("Brutal Slash")
			end
			return nil
		end,
		["Brutal Slash_Thrash_aoe"] = function()
			if cfg.cleave_targets>=cfg.cleave_threshold then
				return lib.SimpleCDCheck("Brutal Slash")
			end
			return nil
		end,
		["Rake_Prowl"] = function()
			if lib.GetAura("Prowl")>0 then
				return lib.SimpleCDCheck("Rake")
			end
			return nil
		end,
		["Savage Roar_nocombat"] = function()
			if cfg.combat then return nil end
			if cfg.AltPower.now>0 then
				return lib.SimpleCDCheck("Savage Roar",lib.GetAura({"Savage Roar"}))
			end
			return nil
		end,
		["Prowl_nocombat"] = function()
			if cfg.combat then return nil end
			if lib.GetAura("Prowl")==0 and cfg.talents["Bloodtalons"] and lib.GetSpellCD("Prowl")>lib.GetAura({"Bloodtalons"})-cfg.gcd*2 and lib.GetAuraStacks("Bloodtalons")<2 then
				return lib.SimpleCDCheck("Regrowth")
			end
			return lib.SimpleCDCheck("Prowl",lib.GetAura("Prowl"))
		end,
		["Regrowth_Bloodtalons_nocombat"] = function()
			if lib.SpellCasting("Regrowth") or cfg.combat or lib.GetAura("Prowl")>0 then return nil end
			if lib.GetAuraStacks("Bloodtalons")<2 then
				return lib.SimpleCDCheck("Regrowth")
			else
				return lib.SimpleCDCheck("Regrowth",lib.GetAura({"Bloodtalons"}))
			end
		end,
		["Regrowth_Bloodtalons_max"] = function()
			if lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") and cfg.AltPower.now>=5 then
				return lib.SimpleCDCheck("Regrowth")
			end
			return nil
		end,
		["Regrowth_Ailuro Pouncers"] = function()
			if lib.GetAuraStacks("Predatory Swiftness")>1 and lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") then
				return lib.SimpleCDCheck("Regrowth",lib.GetAura({"Bloodtalons"}))
			end
			return nil
		end,
		["Regrowth_Bloodtalons_hardcast"] = function()
			if cfg.AltPower.now==cfg.AltPower.max and lib.Time2Power(cfg.Power.max)>cfg.gcd*2 then
				return lib.SimpleCDCheck("Regrowth",math.max(lib.GetAura({"Tiger's Fury"}),lib.GetAura({"Berserk"}),lib.GetAura({"Predatory Swiftness"})-cfg.gcd,lib.GetAura({"Bloodtalons"})-cfg.gcd))
			end
			return nil
		end,
		["Regrowth_Heal"] = function()
			if lib.GetUnitHealth("player","percent")<=70 and lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") then
				return lib.SimpleCDCheck("Regrowth",lib.GetAura("Prowl"))
			end	
			return nil
		end,
		["Regrowth_Bloodtalons_proc"] = function()
			if lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") then
				return lib.SimpleCDCheck("Regrowth",lib.GetAura({"Predatory Swiftness"})-cfg.gcd*1.5)
			end
			return nil
		end,
		["Regrowth_Bloodtalons_aoe"] = function()
			if lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") then
				return lib.SimpleCDCheck("Regrowth")
			end
			return nil
		end,
		["Cat_noCat"] = function()
			if cfg.shape.name~="Cat" then
				return lib.SimpleCDCheck("Cat")
			end
			return nil
		end,
		["Thrash_noThrash"] = function()
			return lib.SimpleCDCheck("Thrash",lib.GetAura({"Thrash"})-4.5)
		end,
		["Rake_Bloodtalons"] = function()
			if cfg.noaoe or cfg.cleave_targets<cfg.cleave_threshold then
				if cfg.AltPower.now==0 and lib.GetAura({"Bloodtalons"})>lib.GetSpellCD("Rake") then
					if cfg.Cat.Rake[cfg.GUID["target"]]<lib.AurasCount(cfg.Cat.Buffs_Rake) then
						return lib.SimpleCDCheck("Rake")
					end
				end
			end
			return nil
		end,
		["Rake_noRake"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.noaoe or cfg.cleave_targets<6 then
				if cfg.Cat.Rake[cfg.GUID["target"]]<lib.AurasCount(cfg.Cat.Buffs_Rake) then
					return lib.SimpleCDCheck("Rake")
				else
					return lib.SimpleCDCheck("Rake",lib.GetAura({"Rake"}))
				end
			end
			return nil
		end,
		["Rake_noRake_renew"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.noaoe or cfg.cleave_targets<6 then
				if cfg.talents["Bloodtalons"] and lib.GetAura({"Bloodtalons"})>lib.GetSpellCD("Rake") then
					return lib.SimpleCDCheck("Rake",lib.GetAura({"Rake"})-5)
				else
					return lib.SimpleCDCheck("Rake",lib.GetAura({"Rake"})-cfg.cat_rake)
				end
			end
			return nil
		end,
		["Rake_noRake_aoe"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.cleave_targets>3 and cfg.cleave_targets<=8 then
				return lib.SimpleCDCheck("Rake",lib.GetAura({"Rake"}))
			end
			return nil
		end,
		--[[["Ashamane's Frenzy"] = function()
			if cfg.AltPower.now>cfg.AltPower.max-3 then return nil end
			if lib.GetAura({"Tiger's Fury"})>lib.GetSpellCD("Ashamane's Frenzy") then
				return lib.SimpleCDCheck("Ashamane's Frenzy")
			end
			return nil
		end,]]
		["Ashamane's Frenzy"] = function()
			if cfg.AltPower.now>cfg.AltPower.max-3 then return nil end
			if (not cfg.talents["Savage Roar"] or (cfg.talents["Savage Roar"] and lib.GetAura({"Savage Roar"})>lib.GetSpellCD("Ashamane's Frenzy")))
			and (not cfg.talents["Bloodtalons"] or (cfg.talents["Bloodtalons"] and lib.GetAura({"Bloodtalons"})>lib.GetSpellCD("Ashamane's Frenzy")))
			and (lib.GetAura({"Tiger's Fury"})>lib.GetSpellCD("Ashamane's Frenzy")
			or lib.GetAura({"Berserk"})>lib.GetSpellCD("Ashamane's Frenzy")) then
				return lib.SimpleCDCheck("Ashamane's Frenzy")
			end
			return nil
		end,
		--[[["Ashamane's Frenzy"] = function()
			if cfg.AltPower.now>cfg.AltPower.max-3 then return nil end
			if (not cfg.talents["Savage Roar"] or (cfg.talents["Savage Roar"] and lib.GetAura({"Savage Roar"})>lib.GetSpellCD("Ashamane's Frenzy")))
			and lib.GetAura({"Tiger's Fury"})>lib.GetSpellCD("Ashamane's Frenzy") then
				return lib.SimpleCDCheck("Ashamane's Frenzy")
			end
			return nil
		end,]]
		["Elune's Guidance"] = function()
			if cfg.AltPower.now==0 and cfg.Power.now<cfg.Power.max then
				return lib.SimpleCDCheck("Elune's Guidance")
			end
			return nil
		end,
		
		["Shred_nomax"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.noaoe or cfg.cleave_targets<cfg.cleave_threshold then
				if lib.GetAura({"Bloodtalons"})>lib.GetSpellCD("Shred") and lib.GetAura({"Clearcasting"})>lib.GetSpellCD("Shred") then
					return lib.SimpleCDCheck("Shred",lib.Time2Power(lib.GetSpellCost("Rake")))
				else
					return lib.SimpleCDCheck("Shred")
				end
			else
				return lib.SimpleCDCheck("Shred",lib.Time2Power(50))
			end
		end,
		["Shred"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.noaoe then
				return lib.SimpleCDCheck("Shred")
			else
				if cfg.talents["Brutal Slash"] then --and lib.GetAura({"Thrash"})<=cfg.cat_thrash
					if cfg.cleave_targets>=9 then
						return nil
					else
						if cfg.cleave_targets>=cfg.cleave_threshold then
							if lib.GetAura({"Thrash"})-cfg.cat_thrash<lib.GetSpellCD("Thrash") then
								return nil
							else
								return lib.SimpleCDCheck("Shred")
							end
						else
							return lib.SimpleCDCheck("Shred")
						end
					end
				else
					if cfg.cleave_targets>=cfg.cleave_threshold then
						return nil
					else
						return lib.SimpleCDCheck("Shred")
					end
				end
			end
			return nil
		end,
		["Brutal Slash"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			return lib.SimpleCDCheck("Brutal Slash")
		end,
		["Brutal Slash_nomax"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			return lib.SimpleCDCheck("Brutal Slash",lib.GetSpellCD("Brutal Slash",nil,lib.GetSpellMaxCharges("Brutal Slash")))
		end,
		["Brutal Slash_single"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.noaoe then
				return lib.SimpleCDCheck("Brutal Slash")
			else
				if lib.GetAura({"Berserk"})>lib.GetSpellCD("Brutal Slash") or lib.GetAura({"Tiger's Fury"})>lib.GetSpellCD("Brutal Slash") then
					return lib.SimpleCDCheck("Brutal Slash")
				else
					return lib.SimpleCDCheck("Brutal Slash",lib.GetSpellCD("Brutal Slash",nil,lib.GetSpellMaxCharges("Brutal Slash")))
				end
			end
			return nil
		end,
		["Swipe"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			return lib.SimpleCDCheck("Swipe")
		end,
		["Savage Roar_noSavage Roar"] = function()
			if (cfg.talents["Bloodtalons"] and cfg.AltPower.now==cfg.AltPower.max) or (not cfg.talents["Bloodtalons"] and cfg.AltPower.now>0) then
				return lib.SimpleCDCheck("Savage Roar",lib.GetAura({"Savage Roar"}))
			end
			return nil
		end,
		
		["Savage Roar_noSavage Roar_renew"] = function()
			if cfg.AltPower.now>=5 then
				if lib.GetAura({"Berserk"})>lib.GetSpellCD("Savage Roar") or lib.GetAura({"Elune's Guidance"})>lib.GetSpellCD("Savage Roar") then
					return lib.SimpleCDCheck("Savage Roar",lib.GetAura({"Savage Roar"})-cfg.cat_roar)
				else
					return lib.SimpleCDCheck("Savage Roar",math.min(lib.GetAura({"Rake"})-cfg.gcd,lib.Time2Power(cfg.Power.max),lib.GetAura({"Savage Roar"})-cfg.cat_roar))
				end
			end
			return nil
		end,
		["Moonfire_noMoonfire"] = function()
			if lib.GetAura({"Rake"})<lib.GetSpellCD("Moonfire") then return nil end
			if cfg.AltPower.now==cfg.AltPower.max then return nil end
			if cfg.noaoe or cfg.cleave_targets<6 then
				return lib.SimpleCDCheck("Moonfire",lib.GetAura({"Moonfire"})-cfg.cat_moonfire)
			end
			return nil
		end,
		["Moonfire_range"] = function()
			if lib.inrange("Rake") then return nil end
			return lib.SimpleCDCheck("Moonfire",math.max(lib.GetAura({"Moonfire"})-cfg.cat_moonfire,lib.GetAura("Prowl")))
		end,
		["Rip_buffed"] = function()
			if cfg.AltPower.now<5 then return nil end
			if lib.GetAura({"Rip"})>lib.GetSpellCD("Rip") and cfg.Cat.Rip[cfg.GUID["target"]]<lib.AurasCount(cfg.Cat.Buffs_Rip) then
				return lib.SimpleCDCheck("Rip")
			end
		end,
		--[[["Rip_noRip"] = function()
			if cfg.AltPower.now<5 then return nil end
			if lib.GetAura({"Rip"})>lib.GetSpellCD("Ferocious Bite") and (lib.GetUnitHealth("target","percent")<25 or cfg.talents["Sabertooth"]) then
				return nil
			end
			if not cfg.talents["Savage Roar"] or (cfg.talents["Savage Roar"] and lib.GetAura({"Savage Roar"})>lib.GetSpellCD("Rip") and lib.GetAura({"Savage Roar"})>lib.GetAura({"Rip"})-cfg.cat_rip) then
				return lib.SimpleCDCheck("Rip",lib.GetAura({"Rip"}))
			end
			return nil
		end,
		["Rip_noRip_renew"] = function()
			if cfg.AltPower.now<5 then return nil end
			if lib.GetAura({"Rip"})>lib.GetSpellCD("Ferocious Bite") and (lib.GetUnitHealth("target","percent")<25 or cfg.talents["Sabertooth"]) then
				return nil
			end
			if not cfg.talents["Savage Roar"] or (cfg.talents["Savage Roar"] and lib.GetAura({"Savage Roar"})>lib.GetSpellCD("Rip") and lib.GetAura({"Savage Roar"})>lib.GetAura({"Rip"})-cfg.cat_rip) then
				return lib.SimpleCDCheck("Rip",lib.GetAura({"Rip"})-cfg.cat_rip)
			end
			return nil
		end,]]
		["Rip_noRip"] = function()
			if cfg.AltPower.now<5 then return nil end
			if cfg.noaoe or cfg.cleave_targets<8 then
				if lib.GetAura({"Rip"})<lib.GetSpellCD("Rip") then
					return lib.SimpleCDCheck("Rip")
				end
				if (lib.GetUnitHealth("target","percent")<25 or cfg.talents["Sabertooth"]) and lib.GetAura({"Rip"})>lib.Time2Power(25+lib.GetSpellCost("Ferocious Bite")) then
					return lib.SimpleCDCheck("Ferocious Bite",lib.Time2Power(25+lib.GetSpellCost("Ferocious Bite")))
				end
				return lib.SimpleCDCheck("Rip",lib.GetAura({"Rip"})-cfg.cat_rip)
			end
			
			return nil
		end,
		["Ferocious Bite_5"] = function()
			if lib.GetAura({"Rip"})<lib.GetSpellCD("Ferocious Bite") then return nil end
			if cfg.AltPower.now>=5 then
				if lib.GetAura({"Berserk"})>lib.Time2Power(25+lib.GetSpellCost("Ferocious Bite")) then
					if lib.GetAura({"Rip"})<lib.Time2Power(25+lib.GetSpellCost("Ferocious Bite")) then return nil end
					return lib.SimpleCDCheck("Ferocious Bite",lib.Time2Power(25+lib.GetSpellCost("Ferocious Bite")))
				end
				if not cfg.talents["Savage Roar"] then
					if lib.GetAura({"Rip"})<math.min(lib.GetAura({"Rake"})-cfg.gcd,lib.Time2Power(cfg.Power.max)) then return nil end
					return lib.SimpleCDCheck("Ferocious Bite",math.min(lib.GetAura({"Rake"})-cfg.gcd,lib.Time2Power(cfg.Power.max)))
				end
			end
			return nil
		end,
		--[[["Ferocious Bite_5"] = function()
			if cfg.AltPower.now>=5 then
				if lib.GetAura({"Berserk"})>lib.GetSpellCD("Ferocious Bite") or lib.GetAura({"Elune's Guidance"})>lib.GetSpellCD("Ferocious Bite") then
					return lib.SimpleCDCheck("Ferocious Bite")
				else
					return lib.SimpleCDCheck("Ferocious Bite",lib.Time2Power(cfg.Power.max))--,math.min(lib.GetAura({"Rake"})-cfg.gcd,lib.Time2Power(cfg.Power.max)
				end
			end
			return nil
		end,]]
		["CP_5"] = function()
			if cfg.AltPower.now>=5 then
				if lib.GetAura({"Savage Roar"})>lib.GetAura({"Rip"}) then
					return lib.SimpleCDCheck("Rip",math.min(lib.GetAura({"Rake"})-cfg.gcd,lib.Time2Power(cfg.Power.max)))
				else
					return lib.SimpleCDCheck("Savage Roar",math.min(lib.GetAura({"Rake"})-cfg.gcd,lib.Time2Power(cfg.Power.max)))
				end
			end
			return nil
		end,
		--[[["Ferocious Bite_Rip"] = function()
			if cfg.AltPower.now==0 then return nil end
			if lib.GetUnitHealth("target","percent")<25 or cfg.talents["Sabertooth"] then
				if lib.GetAura({"Rip"})>lib.GetSpellCD("Ferocious Bite") then 
					if lib.GetAura({"Rip"})-3<=lib.GetSpellCD("Ferocious Bite") then
						if cfg.talents["Bloodtalons"] and lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") then
							return lib.SimpleCDCheck("Regrowth")
						else
							return lib.SimpleCDCheck("Ferocious Bite")
						end
					end
					if cfg.AltPower.now>=5 then
						if not cfg.talents["Savage Roar"] or (cfg.talents["Savage Roar"] and lib.GetAura({"Savage Roar"})>lib.Time2Power(lib.GetSpellCost("Ferocious Bite")+25)) then
							return lib.SimpleCDCheck("Ferocious Bite",lib.Time2Power(lib.GetSpellCost("Ferocious Bite")+25))
						end
					end
				end
			end
			return nil
		end,]]
		["Ferocious Bite_Rip"] = function()
			if lib.GetAura({"Rip"})<lib.GetSpellCD("Ferocious Bite") then return nil end
			if cfg.AltPower.now==0 then return nil end
			if lib.GetUnitHealth("target","percent")<25 or cfg.talents["Sabertooth"] then
				if lib.GetAura({"Rip"})>lib.GetSpellCD("Ferocious Bite") then 
					if cfg.talents["Bloodtalons"] and lib.GetAura({"Bloodtalons"})==0 and lib.GetAura({"Predatory Swiftness"})>lib.GetSpellCD("Regrowth") and lib.GetAura({"Rip"})-3<lib.GetSpellCD("Ferocious Bite") then
						return lib.SimpleCDCheck("Regrowth")
					end
					return lib.SimpleCDCheck("Ferocious Bite",lib.GetAura({"Rip"})-3)
				end
			end
			return nil
		end,
		["Tiger's Fury"] = function()
			if cfg.Power.now+lib.TimeEnergyGain(lib.GetSpellCD("Tiger's Fury"))+(lib.IsAura("Clearcasting") and 80 or 60)<=cfg.Power.max then
				return lib.SimpleCDCheck("Tiger's Fury")
			end
			return nil
		end,
		["Berserk_TF"] = function()
			--return lib.SimpleCDCheck("Berserk")
			if lib.GetAura({"Tiger's Fury"})>lib.GetSpellCD("Berserk") then
				return lib.SimpleCDCheck("Berserk",lib.GetAura({"Berserk"}))
			end
			return nil
		end,
		
		
		["Ravage!"] = function()
			if lib.GetLastSpell({"Ravage!"}) then return nil end
			return lib.SimpleCDCheck("Ravage!")
		end,
	
		
		["Swipe"] = function()
			return lib.SimpleCDCheck("Swipe")
			end,
		
		["Shred_OoC"] = function()
			if lib.GetAura({"Clearcasting"})>lib.GetSpellCD("Shred") then
				return lib.SimpleCDCheck("Shred")
			end
			return nil
		end,
--[[		["Rake"] = function()
			if not lib.GetLastSpell({"Rake"}) then
				if lib.GetAura({"Tiger's Fury"})>lib.GetSpellCD("Rake") then
					return lib.SimpleCDCheck("Rake",(lib.GetAura({"Rake"})-9))
				else
					return lib.SimpleCDCheck("Rake",(lib.GetAura({"Rake"})-2))
				end
			end
			return nil
		end,]]
		
		["FB_Berserk"] = function()
			if cfg.AltPower.now==5 and lib.GetAura({"Rip"})>(5+lib.GetSpellCD("Ferocious Bite")) and lib.GetAuras("Savage Roar")>(3+lib.GetSpellCD("Ferocious Bite")) and lib.GetAura({"Berserk"})>lib.GetSpellCD("Ferocious Bite") then
				return lib.SimpleCDCheck("Ferocious Bite")
			end
			return nil
		end,
		["Ferocious Bite"] = function()
			if cfg.AltPower.now==5 and lib.GetAura({"Rip"})>=(14+lib.GetSpellCD("Ferocious Bite")) and lib.GetAuras("Savage Roar")>=(10+lib.GetSpellCD("Ferocious Bite")) then
				return lib.SimpleCDCheck("Ferocious Bite")
			end
			return nil
		end,
		["FB_biw"] = function()
			if cfg.health<=cfg.bloodinwater and lib.GetAura({"Rip"})>lib.GetSpellCD("Ferocious Bite") then
				if cfg.AltPower.now==5 and lib.GetAuras("Savage Roar")>lib.GetSpellCD("Ferocious Bite") then
					return lib.SimpleCDCheck("Ferocious Bite")
				elseif cfg.AltPower.now>0 then
					return lib.SimpleCDCheck("Ferocious Bite",lib.GetAura({"Rip"})-4)
				end
			end
			return nil
		end,
		["Rip"] = function()
			if cfg.AltPower.now==5 and (lib.GetAura({"Berserk"})>lib.GetSpellCD("Rip") or lib.GetAura({"Rip"})<=lib.GetSpellCD("Tiger's Fury")) then
				return lib.SimpleCDCheck("Rip",lib.GetAura({"Rip"})-2)
			end
			return nil
		end,
		["Shred_Rip"] = function()
			if lib.GetAura({"Rip"})>0 and cfg.health>25 then
				return lib.SimpleCDCheck("Shred",(lib.GetAura({"Rip"})-4))
			end
			return nil
		end,
		
		
		["Charge"] = function()
			if lib.inrange("Charge") then --and (not lib.inrange("Shred")) 
				return lib.SimpleCDCheck("Charge")
			end
			return nil
		end,
	}

	cfg.plist=cfg.plistdps
	
	lib.SetInterrupt("Kick",{106839})
	
	lib.AddRangeCheck({
	{"Shred",nil},
	{"Kick",{0,0,1,1}}
	--(cfg.talents["Lunar Inspiration"] and {"Moonfire",{1,1,0,1}}),
	})
	
	if cfg.talents["Lunar Inspiration"] then
		lib.AddRangeCheck({{"Moonfire",{1,1,0,1}}})
	end

	
	return true
end

lib.classpostload["DRUID"] = function()
	
	--lib.AddSpell("Wrath",{5176}) -- Wrath
	--cfg.gcd_spell = "Wrath"
	
	
	--lib.AddAura("Instincts",61336,"buff","player") -- Instincts
	
	--lib.AddAura("Barkskin",22812,"buff","player") -- Barkskin
	
	--[[lib.AddSpell("Mark",{1126}) -- Mark of the Wild
	cfg.case["Mark_nobuff"] = function()
		return lib.SimpleCDCheck("Mark",math.min(lib.GetAuras("Stats"),lib.GetAuras("Versatility")))
	end]]
	
	
	
	
	
	--lib.AddSpell("Berserk",{106952}) -- Berserk

	
	lib.CD = function()
		lib.CDadd("Kick")
		lib.CDadd("Rage of the Sleeper")
		lib.CDadd("Frenzied Regeneration")
		lib.CDadd("Maul")
		lib.CDadd("Ironfur")
		lib.CDadd("Mark of Ursol")
		lib.CDadd("Regrowth")
		lib.CDadd("Prowl")
		lib.CDadd("Instincts")
		lib.CDturnoff("Instincts")
		lib.CDadd("Barkskin")
		lib.CDturnoff("Barkskin")
		
		lib.CDadd("Celestial Alignment")
		lib.CDadd("Warrior of Elune")
		lib.CDadd("Force of Nature")
		lib.CDadd("Astral Communion")
		lib.CDadd("Brutal Slash")
		lib.CDadd("Ashamane's Frenzy")
		lib.CDadd("Berserk")
		lib.CDadd("Elune's Guidance")
		lib.CDadd("Tiger's Fury")
	end
end
end
